# 替代排序

> 原文： [https://www.geeksforgeeks.org/alternative-sorting/](https://www.geeksforgeeks.org/alternative-sorting/)

给定一个整数数组，以第一个元素为第一个最大值，第二个元素为第一个最小值的方式打印该数组，依此类推。

**示例**：

```
Input : arr[] = {7, 1, 2, 3, 4, 5, 6}
Output : 7 1 6 2 5 3 4

Input : arr[] = {1, 6, 9, 4, 3, 7, 8, 2}
Output : 9 1 8 2 7 3 6 4

```

## [推荐：请先在“ ***<u>实践</u>*** ”上解决它，然后再继续解决。](https://practice.geeksforgeeks.org/problems/alternative-sorting/0)

一个**简单解决方案**是先打印最大元素，然后再打印最小值，然后再打印第二个最大值，依此类推。 该方法的时间复杂度为 O（n <sup>2</sup> ）。

**有效解决方案**涉及以下步骤。
1）使用 O（n Log n）算法对输入数组进行排序。
2）我们在排序数组中维护两个指针，一个从头开始，一个从头结束。 我们也可以打印由两个指针指向的元素，并将它们彼此相对移动。

## C++ 

```

// C++ program to print an array in alternate 
// sorted manner. 
#include <bits/stdc++.h> 
using namespace std; 

// Function to print alternate sorted values 
void alternateSort(int arr[], int n) 
{ 
    // Sorting the array 
    sort(arr, arr+n); 

    // Printing the last element of array  
    // first and then first element and then  
    // second last element and then second  
    // element and so on. 
    int i = 0, j = n-1; 
    while (i < j) { 
        cout << arr[j--] << " "; 
        cout << arr[i++] << " "; 
    } 

    // If the total element in array is odd  
    // then print the last middle element. 
    if (n % 2 != 0) 
        cout << arr[i]; 
} 

// Driver code 
int main() 
{ 
    int arr[] = {1, 12, 4, 6, 7, 10}; 
    int n = sizeof(arr)/sizeof(arr[0]); 
    alternateSort(arr, n); 
    return 0; 
} 

```

## 爪哇

```

// Java program to print an array in alternate 
// sorted manner 
import java.io.*; 
import java.util.Arrays; 

class AlternativeString 
{ 
    // Function to print alternate sorted values 
    static void alternateSort(int arr[], int n) 
    { 
        Arrays.sort(arr); 

        // Printing the last element of array  
        // first and then first element and then  
        // second last element and then second  
        // element and so on. 
        int i = 0, j = n-1; 
        while (i < j) { 
            System.out.print(arr[j--] + " "); 
            System.out.print(arr[i++] + " "); 
        } 

        // If the total element in array is odd  
        // then print the last middle element. 
        if (n % 2 != 0) 
            System.out.print(arr[i]); 
    } 

    /* Driver program to test above functions */
    public static void main (String[] args) 
    { 
        int arr[] = {1, 12, 4, 6, 7, 10}; 
        int n = arr.length; 
        alternateSort(arr, n); 
    } 
} 
/*This code is contributed by Prakriti Gupta*/

```

## Python3

```

# Python 3 program to print an array 
# in alternate sorted manner. 

# Function to print alternate sorted 
# values 
def alternateSort(arr, n): 

    # Sorting the array 
    arr.sort()  

    # Printing the last element of array  
    # first and then first element and then  
    # second last element and then second  
    # element and so on. 
    i = 0
    j = n-1

    while (i < j):  

        print(arr[j], end =" ") 
        j-= 1
        print(arr[i], end =" ") 
        i+= 1

    # If the total element in array is odd  
    # then print the last middle element. 
    if (n % 2 != 0): 
        print(arr[i])  

# Driver code 
arr = [1, 12, 4, 6, 7, 10]  
n = len(arr) 

alternateSort(arr, n)  

# This code is contributed by 
# Smitha Dinesh Semwal 

```

## C# 

```

// C# program to print an array in alternate 
// sorted manner 
using System; 

class AlternativeString { 

    // Function to print alternate sorted values 
    static void alternateSort(int[] arr, int n) 
    { 
        Array.Sort(arr); 

        // Printing the last element of array 
        // first and then first element and then 
        // second last element and then second 
        // element and so on. 
        int i = 0, j = n - 1; 
        while (i < j) { 
            Console.Write(arr[j--] + " "); 
            Console.Write(arr[i++] + " "); 
        } 

        // If the total element in array is odd 
        // then print the last middle element. 
        if (n % 2 != 0) 
            Console.WriteLine(arr[i]); 
    } 

    /* Driver program to test above functions */
    public static void Main() 
    { 
        int[] arr = { 1, 12, 4, 6, 7, 10 }; 
        int n = arr.Length; 
        alternateSort(arr, n); 
    } 
} 

// This article is contributed by vt_m. 

```

## 的 PHP

```

<?php 
// PHP program to print an array in  
// alternate sorted manner. 

// Function to print alternate 
// sorted values 
function alternateSort($arr, $n) 
{ 
    // Sorting the array 
    sort($arr); 

    // Printing the last element  
    // of array  first and then  
    // first element and then second  
    // last element and then second   
    // element and so on. 
    $i = 0; 
    $j = $n - 1; 
    while ($i < $j) 
    { 
        echo $arr[$j--]." "; 
        echo $arr[$i++]." "; 
    } 

    // If the total element in array   
    // is odd then print the last  
    // middle element. 
    if ($n % 2 != 0) 
        echo $arr[$i]; 
} 

// Driver code 
$arr= array(1, 12, 4, 6, 7, 10); 
$n = sizeof($arr) / sizeof($arr[0]); 

alternateSort($arr, $n); 

// This code is contributed by Mithun Kumar 
?> 

```

**Output :**

```
12 1 10 4 7 6 

```

**时间复杂度**： O（n Log n）
**辅助空间**： O（1）

本文由 **Sachin Bisht** 提供。 如果您喜欢 GeeksforGeeks 并希望做出贡献，则还可以使用 [tribution.geeksforgeeks.org](http://www.contribute.geeksforgeeks.org) 撰写文章，或将您的文章邮寄至 tribution@geeksforgeeks.org。 查看您的文章出现在 GeeksforGeeks 主页上，并帮助其他 Geeks。

如果发现任何不正确的地方，或者想分享有关上述主题的更多信息，请写评论。

现在不要停下来，将您的学习提高到一个新的水平。 借助最受信任的课程，学习数据结构和算法的所有重要概念： [DSA Self Paced](https://practice.geeksforgeeks.org/courses/dsa-self-paced?utm_source=geeksforgeeks&utm_medium=article&utm_campaign=gfg_article_dsa_content_bottom) 。 以对学生友好的价格准备好行业。