# 矩阵的标量乘法程序

> 原文： [https://www.geeksforgeeks.org/program-for-scalar-multiplication-of-a-matrix/](https://www.geeksforgeeks.org/program-for-scalar-multiplication-of-a-matrix/)

给定一个矩阵和一个标量元素 k，我们的任务是找出该矩阵的标量积。

**示例**：

```
Input : mat[][] = {{2, 3}
                   {5, 4}}
        k = 5
Output : 10 15 
         25 20 
We multiply 5 with every element.

Input : 1 2 3 
        4 5 6
        7 8 9
        k = 4
Output :  4 8  12
          16 20 24
          28 32 36 

```

## [推荐：在继续进行解决之前，请先在 ***<u>{IDE}</u>*** 上尝试您的方法。](https://ide.geeksforgeeks.org/)

数为 k（标量）的**标量乘法**，将其乘以矩阵中的每个条目。 矩阵 A 为矩阵 kA。

## C++ 

```

// C++ program to find the scalar product  
// of a matrix 
#include <bits/stdc++.h> 
using namespace std; 

// Size of given matrix 
#define N 3 

void scalarProductMat(int mat[][N], int k) 
{ 
    // scalar element is multiplied by the matrix 
    for (int i = 0; i < N; i++)  
        for (int j = 0; j < N; j++)  
            mat[i][j] = mat[i][j] * k;         
} 

// Driver code 
int main() 
{ 
    int mat[N][N] = { { 1, 2, 3 }, 
                      { 4, 5, 6 }, 
                      { 7, 8, 9 } }; 
    int k = 4; 

    scalarProductMat(mat, k); 

    // to display the resultant matrix 
    printf("Scalar Product Matrix is : \n"); 
    for (int i = 0; i < N; i++) { 
        for (int j = 0; j < N; j++)  
            printf("%d ", mat[i][j]); 
        printf("\n"); 
    } 

    return 0; 
} 

```

## 爪哇

```

// Java program to find 
// the scalar product  
// of a matrix 
import java.io.*; 

class GFG { 

static final int N = 3; 
static void scalarProductMat(int mat[][],  
                                  int k) 
{ 

    // scalar element is multiplied 
    // by the matrix 
    for (int i = 0; i < N; i++)  
        for (int j = 0; j < N; j++)  
            mat[i][j] = mat[i][j] * k;  
} 

// Driver code 
public static void main (String[] args) 
{ 
    int mat[][] = { { 1, 2, 3 }, 
                    { 4, 5, 6 }, 
                    { 7, 8, 9 } }; 
    int k = 4; 

    scalarProductMat(mat, k); 

    // to display the resultant matrix 
    System.out.println("Scalar Product Matrix is : "); 

    for (int i = 0; i < N; i++) 
    { 
        for (int j = 0; j < N; j++)  
            System.out.print(mat[i][j] + " "); 
        System.out.println(); 
    } 
} 
} 

// This code is contributed by Ajit. 

```

## Python 3

```

# Python 3 program to find the scalar  
# product of a matrix 

# Size of given matrix 
N = 3

def scalarProductMat( mat, k): 

    # scalar element is multiplied  
    # by the matrix 
    for i in range( N): 
        for j in range( N):  
            mat[i][j] = mat[i][j] * k      

# Driver code 
if __name__ == "__main__": 

    mat = [[ 1, 2, 3 ], 
           [ 4, 5, 6 ], 
           [ 7, 8, 9 ]] 
    k = 4

    scalarProductMat(mat, k) 

    # to display the resultant matrix 
    print("Scalar Product Matrix is : ") 
    for i in range(N): 
        for j in range(N): 
            print(mat[i][j], end = " ") 
        print() 

# This code is contributed by ita_c 

```

## C# 

```

// C# program to find 
// the scalar product  
// of a matrix 
using System; 

class GFG{ 

static int N = 3; 
static void scalarProductMat(int[,] mat,  
                                  int k) 
{ 

    // scalar element is multiplied  
    // by the matrix 
    for (int i = 0; i < N; i++)  
        for (int j = 0; j < N; j++)  
            mat[i,j] = mat[i, j] * k;      
} 

// Driver code 
static public void Main () 
{ 
    int[,] mat = {{1, 2, 3}, 
                  {4, 5, 6}, 
                  {7, 8, 9}}; 
    int k = 4; 

    scalarProductMat(mat, k); 

    // to display the resultant matrix 
    Console.WriteLine("Scalar Product Matrix is : "); 

    for (int i = 0; i < N; i++) { 
        for (int j = 0; j < N; j++)  
            Console.Write(mat[i, j] + " "); 
        Console.WriteLine(); 
    } 
} 
} 

// This code is contributed by Ajit. 

```

## 的 PHP

```

<?php 
// PHP program to find 
// the scalar product  
// of a matrix 

function scalarProductMat($mat,  
                          $k) 
{ 
    $N = 3; 

    // scalar element is multiplied 
    // by the matrix 
    for ( $i = 0; $i < $N; $i++)  
        for ($j = 0; $j < $N; $j++)  
            $mat[$i][$j] = $mat[$i][$j] * $k;  

    return $mat; 
} 

// Driver code 
$N = 3; 
$mat = array(array(1, 2, 3 ), 
             array( 4, 5, 6 ), 
             array(7, 8, 9 )); 
$k = 4; 

$mat1 = scalarProductMat($mat, $k); 

// to display the resultant matrix 
echo("Scalar Product Matrix is : " . "\n"); 

for ($i = 0; $i < $N; $i++) 
{ 
    for ($j = 0; $j < $N; $j++)  
        echo($mat1[$i][$j] . " "); 
    echo "\n"; 
} 

// This code is contributed 
// by Mukul Singh 

```

**Output:**

```
Scalar Product Matrix is : 
4 8 12 
16 20 24 
28 32 36

```

现在不要停下来，将您的学习提高到一个新的水平。 借助最受信任的课程，学习数据结构和算法的所有重要概念： [DSA Self Paced](https://practice.geeksforgeeks.org/courses/dsa-self-paced?utm_source=geeksforgeeks&utm_medium=article&utm_campaign=gfg_article_dsa_content_bottom) 。 以对学生友好的价格准备好行业。

* * *

* * *

如果您喜欢 GeeksforGeeks 并希望做出贡献，则还可以使用 [tribution.geeksforgeeks.org](https://contribute.geeksforgeeks.org/) 撰写文章，或将您的文章邮寄至 tribution@geeksforgeeks.org。 查看您的文章出现在 GeeksforGeeks 主页上，并帮助其他 Geeks。

如果您发现任何不正确的地方，请单击下面的“改进文章”按钮，以改进本文。