# 二维数组中的按行排序

> 原文： [https://www.geeksforgeeks.org/row-wise-sorting-2d-array/](https://www.geeksforgeeks.org/row-wise-sorting-2d-array/)

给定一个 2D 数组，对该数组的每一行进行排序并打印结果。

**示例**：

```
Input :
77 11 22 3
11 89 1 12
32 11 56 7
11 22 44 33
Output :
3 11 22 77
1 11 12 89
7 11 32 56
11 22 33 44

Input :
8 6 4 5
3 5 2 1
9 7 4 2
7 8 9 5
Output :
4 5 6 8
1 2 3 5
2 4 7 9
5 7 8 9

```

## [推荐：在继续进行解决之前，请先在 ***<u>{IDE}</u>*** 上尝试您的方法。](https://ide.geeksforgeeks.org/)

**方法 1（使用冒泡排序）**
开始遍历给定 2D 数组的每一行，并使用有效的排序算法对每一行的元素进行排序。

## 爪哇

```

// Java code to sort 2D matrix row-wise 
import java.io.*; 

public class Sort2DMatrix { 

    static int sortRowWise(int m[][]) 
    { 
        // loop for rows of matrix 
        for (int i = 0; i < m.length; i++) { 

            // loop for column of matrix 
            for (int j = 0; j < m[i].length; j++) { 

                // loop for comparison and swapping 
                for (int k = 0; k < m[i].length - j - 1; k++) { 
                    if (m[i][k] > m[i][k + 1]) { 

                        // swapping of elements 
                        int t = m[i][k]; 
                        m[i][k] = m[i][k + 1]; 
                        m[i][k + 1] = t; 
                    } 
                } 
            } 
        } 

        // printing the sorted matrix 
        for (int i = 0; i < m.length; i++) { 
            for (int j = 0; j < m[i].length; j++) 
                System.out.print(m[i][j] + " "); 
            System.out.println(); 
        } 

        return 0; 
    } 

    // driver code 
    public static void main(String args[]) 
    { 
        int m[][] = { { 9, 8, 7, 1 }, 
                      { 7, 3, 0, 2 }, 
                      { 9, 5, 3, 2 }, 
                      { 6, 3, 1, 2 } }; 
        sortRowWise(m); 
    } 
} 

```

## Python3

```

# Python3 code to sort 2D matrix row-wise 
def sortRowWise(m): 

    # loop for rows of matrix 
    for i in range(len(m)): 

        # loop for column of matrix 
        for j in range(len(m[i])): 

            # loop for comparison and swapping 
            for k in range(len(m[i]) - j - 1): 

                if (m[i][k] > m[i][k + 1]): 

                    # swapping of elements 
                    t = m[i][k] 
                    m[i][k] = m[i][k + 1] 
                    m[i][k + 1] = t 

    # printing the sorted matrix 
    for i in range(len(m)): 
        for j in range(len(m[i])): 
            print(m[i][j], end=" ") 
        print() 

# Driver code 
m = [[9, 8, 7, 1 ],[7, 3, 0, 2],[9, 5, 3, 2],[ 6, 3, 1, 2 ]] 
sortRowWise(m) 

# This code is contributed by shubhamsingh10 

```

## C# 

```

// C# code to sort 2D matrix row-wise 
using System; 

class GFG  
{ 
static int sortRowWise(int [,]m) 
{ 
    // loop for rows of matrix 
    for (int i = 0;  
             i < m.GetLength(0); i++) 
    { 

        // loop for column of matrix 
        for (int j = 0;  
                 j < m.GetLength(1); j++)  
        { 

            // loop for comparison and swapping 
            for (int k = 0;  
                     k < m.GetLength(1) - j - 1; k++)  
            { 
                if (m[i, k] > m[i, k + 1])  
                { 

                    // swapping of elements 
                    int t = m[i, k]; 
                    m[i, k] = m[i, k + 1]; 
                    m[i, k + 1] = t; 
                } 
            } 
        } 
    } 

    // printing the sorted matrix 
    for (int i = 0; 
             i < m.GetLength(0); i++)  
    { 
        for (int j = 0; 
                 j < m.GetLength(1); j++) 
            Console.Write(m[i, j] + " "); 
        Console.WriteLine(); 
    } 
    return 0; 
} 

// Driver Code 
public static void Main(String []args) 
{ 
    int [,]m = {{ 9, 8, 7, 1 }, 
                { 7, 3, 0, 2 }, 
                { 9, 5, 3, 2 }, 
                { 6, 3, 1, 2 }}; 
    sortRowWise(m); 
} 
} 

// This code is contributed by 29AjayKumar 

```

**Output:**

```
1 7 8 9 
0 2 3 7 
2 3 5 9 
1 2 3 6

```

**方法 2（使用库函数）**
想法是对矩阵的每一行使用 [Arrays.sort（）](https://www.geeksforgeeks.org/arrays-sort-in-java-with-examples/)。

## Java

```

// Java code to sort 2D matrix row-wise 
import java.io.*; 
import java.util.Arrays; 

public class Sort2DMatrix { 

    static int sortRowWise(int m[][]) 
    { 
        // One by one sort individual rows. 
        for (int i = 0; i < m.length; i++) 
            Arrays.sort(m[i]); 

        // printing the sorted matrix 
        for (int i = 0; i < m.length; i++) { 
            for (int j = 0; j < m[i].length; j++) 
                System.out.print(m[i][j] + " "); 
            System.out.println(); 
        } 

        return 0; 
    } 

    // driver code 
    public static void main(String args[]) 
    { 
        int m[][] = { { 9, 8, 7, 1 }, 
                      { 7, 3, 0, 2 }, 
                      { 9, 5, 3, 2 }, 
                      { 6, 3, 1, 2 } }; 

        sortRowWise(m); 
    } 
} 

```

## Python3

```

# Python3 code to sort 2D matrix row-wise 
def sortRowWise(m): 

    # One by one sort individual rows. 
    for i in range(len(m)):  
        m[i].sort() 

    # printing the sorted matrix 
    for i in range(len(m)): 
        for j in range(len(m[i])): 
            print(m[i][j], end=" ") 
        print() 

    return 0

# Driver code 
m = [[9, 8, 7, 1 ],[7, 3, 0, 2],[9, 5, 3, 2 ],[ 6, 3, 1, 2]] 

sortRowWise(m) 

# This code is contributed by shubhamsingh10 

```

Output

```
1 7 8 9 
0 2 3 7 
2 3 5 9 
1 2 3 6

```

现在不要停下来，将您的学习提高到一个新的水平。 借助最受信任的课程，学习数据结构和算法的所有重要概念： [DSA Self Paced](https://practice.geeksforgeeks.org/courses/dsa-self-paced?utm_source=geeksforgeeks&utm_medium=article&utm_campaign=gfg_article_dsa_content_bottom) 。 以对学生友好的价格准备好行业。

* * *

* * *

如果您喜欢 GeeksforGeeks 并希望做出贡献，则还可以使用 [tribution.geeksforgeeks.org](https://contribute.geeksforgeeks.org/) 撰写文章，或将您的文章邮寄至 tribution@geeksforgeeks.org。 查看您的文章出现在 GeeksforGeeks 主页上，并帮助其他 Geeks。

如果您发现任何不正确的地方，请单击下面的“改进文章”按钮，以改进本文。