# 检查给定矩阵是否稀疏

> 原文： [https://www.geeksforgeeks.org/check-given-matrix-sparse-not/](https://www.geeksforgeeks.org/check-given-matrix-sparse-not/)

矩阵是具有 m 行和 n 列的二维数据对象，因此共有 m * n 个值。 如果矩阵的大多数值是 0，那么我们说矩阵是稀疏的。
考虑稀疏的定义，如果 0 的数量大于矩阵元素的一半，则认为矩阵是稀疏的，

例子：

```
Input : 1 0 3
        0 0 4
        6 0 0
Output : Yes
There are 5 zeros. This count
is more than half of matrix
size.

Input : 1 2 3
        0 7 8
        5 0 7 
Output: No

```

## [推荐：在继续进行解决之前，请先在 ***<u>{IDE}</u>*** 上尝试您的方法。](https://ide.geeksforgeeks.org/)

要检查矩阵是否为稀疏矩阵，我们只需要检查等于零的元素总数即可。 如果此计数大于（m * n）/ 2，则返回 true。

## CPP

```

// CPP code to check if a matrix is 
// sparse. 
#include <iostream> 
using namespace std; 

const int MAX = 100; 

bool isSparse(int array[][MAX], int m, int n) 
{ 
    int counter = 0; 

    // Count number of zeros in the matrix 
    for (int i = 0; i < m; ++i) 
        for (int j = 0; j < n; ++j) 
            if (array[i][j] == 0) 
                ++counter; 

    return (counter > ((m * n) / 2)); 
} 

// Driver Function 
int main() 
{ 
    int array[][MAX] = { { 1, 0, 3 },  
                        { 0, 0, 4 },  
                        { 6, 0, 0 } }; 

    int m = 3, 
        n = 3; 
    if (isSparse(array, m, n)) 
        cout << "Yes"; 
    else
        cout << "No"; 
} 

```

## 爪哇

```

// Java code to check  
// if a matrix is 
// sparse. 

import java.io.*; 

class GFG { 

    static int MAX = 100; 

    static boolean isSparse(int array[][], int m, int n) 
    { 
        int counter = 0; 

        // Count number of zeros in the matrix 
        for (int i = 0; i < m; ++i) 
            for (int j = 0; j < n; ++j) 
                if (array[i][j] == 0) 
                    ++counter; 

        return (counter > ((m * n) / 2)); 
    } 

    // Driver Function 
    public static void main(String args[]) 
    { 
        int array[][] = { { 1, 0, 3 },  
                            { 0, 0, 4 },  
                            { 6, 0, 0 } }; 

        int m = 3, 
            n = 3; 
        if (isSparse(array, m, n)) 
            System.out.println("Yes"); 
        else
            System.out.println("No"); 
    } 
} 

// This code is contributed by 
// Nikita Tiwari. 

```

## Python3

```

# Python 3 code to check 
# if a matrix is 
# sparse. 

MAX = 100

def isSparse(array,m, n) : 

    counter = 0

    # Count number of zeros 
    # in the matrix 
    for i in range(0,m) : 
        for j in range(0,n) : 
            if (array[i][j] == 0) : 
                counter = counter + 1

    return (counter >  
            ((m * n) // 2)) 

# Driver Function 
array = [ [ 1, 0, 3 ], 
          [ 0, 0, 4 ], 
          [ 6, 0, 0 ] ] 
m = 3
n = 3

if (isSparse(array, m, n)) : 
    print("Yes") 
else : 
    print("No") 

# this code is contributed by 
# Nikita tiwari 

```

## C# 

```

// C# code to check if a matrix is 
// sparse. 
using System; 

class GFG { 

    static bool isSparse(int [,]array, int m, 
                                       int n) 
    { 
        int counter = 0; 

        // Count number of zeros in the matrix 
        for (int i = 0; i < m; ++i) 
            for (int j = 0; j < n; ++j) 
                if (array[i,j] == 0) 
                    ++counter; 

        return (counter > ((m * n) / 2)); 
    } 

    // Driver Function 
    public static void Main() 
    { 
        int [,]array = { { 1, 0, 3 },  
                         { 0, 0, 4 },  
                         { 6, 0, 0 } }; 

        int m = 3, 
            n = 3; 

        if (isSparse(array, m, n)) 
            Console.WriteLine("Yes"); 
        else
            Console.WriteLine("No"); 
    } 
} 

// This code is contributed by vt_m. 

```

## 的 PHP

```

<?php 
// PHP code to check if a matrix is 
// sparse. 

$MAX = 100; 

function isSparse( $array, $m, $n) 
{ 
    $counter = 0; 

    // Count number of zeros 
    // in the matrix 
    for ($i = 0; $i < $m; ++$i) 
        for ($j = 0; $j < $n; ++$j) 
            if ($array[$i][$j] == 0) 
                ++$counter; 

    return ($counter > (($m * $n) / 2)); 
} 

    // Driver Code 
    $array = array(array(1, 0, 3),  
                   array(0, 0, 4),  
                   array(6, 0, 0)); 

    $m = 3; 
    $n = 3; 
    if (isSparse($array, $m, $n)) 
        echo "Yes"; 
    else
        echo "No"; 

// This code is contributed by anuj_67\. 
?> 

```

Output:

```
Yes

```

本文由 **Vineet Joshi** 提供。 如果您喜欢 GeeksforGeeks 并希望做出贡献，则也可以使用 [tribution.geeksforgeeks.org](http://www.contribute.geeksforgeeks.org) 撰写文章，或将您的文章邮寄至 tribution@geeksforgeeks.org。 查看您的文章出现在 GeeksforGeeks 主页上，并帮助其他 Geeks。

如果发现任何不正确的地方，或者想分享有关上述主题的更多信息，请写评论。

现在不要停下来，将您的学习提高到一个新的水平。 借助最受信任的课程，学习数据结构和算法的所有重要概念： [DSA Self Paced](https://practice.geeksforgeeks.org/courses/dsa-self-paced?utm_source=geeksforgeeks&utm_medium=article&utm_campaign=gfg_article_dsa_content_bottom) 。 以对学生友好的价格准备好行业。