# 检查矩阵中第 i 行和第 i 列的总和是否相同

> 原文： [https://www.geeksforgeeks.org/check-sums-th-row-th-column-matrix/](https://www.geeksforgeeks.org/check-sums-th-row-th-column-matrix/)

给定矩阵 mat [] []，我们必须检查第 i 行的总和是否等于第 i 列的总和。

**示例**：

```
Input : 1 2 3 4 
        9 5 3 1
        0 3 5 6 
        0 4 5 6
Output : Yes
Sums of 1st row = 10 and 1st column 
are same, i.e., 10 

```

预期的时间复杂度为 O（m x n），其中 m 为行数，n 为列数。

## [推荐：请先在“ ***<u>实践</u>*** ”上解决它，然后再继续解决。](https://practice.geeksforgeeks.org/problems/sums-of-i-th-row-and-i-th-column/0)

这个想法真的很简单。 我们使用嵌套循环来计算每一行和每一列的总和，然后检查它们的总和是否相等。
下面给出上述想法的实现。

## C++ 

```

#include <bits/stdc++.h> 
using namespace std; 
const int MAX = 100; 

// Function to check the if sum of a row 
// is same as corresponding column 
bool areSumSame(int a[][MAX], int n, int m) 
{ 
    int sum1 = 0, sum2 = 0; 
    for (int i = 0; i < n; i++) { 
        sum1 = 0, sum2 = 0; 
        for (int j = 0; j < m; j++) { 
            sum1 += a[i][j]; 
            sum2 += a[j][i]; 
        } 
        if (sum1 == sum2) 
            return true; 
    } 
    return false; 
} 

// Driver Code 
int main() 
{ 
    int n = 4; // number of rows 
    int m = 4; // number of columns 
    int M[n][MAX] = { { 1, 2, 3, 4 }, 
                      { 9, 5, 3, 1 },  
                      { 0, 3, 5, 6 }, 
                      { 0, 4, 5, 6 } }; 
    cout << areSumSame(M, n, m) << "n"; 
    return 0; 
} 

```