# 程序检查矩阵是否对称

> 原文： [https://www.geeksforgeeks.org/program-to-check-if-a-matrix-is-symmetric/](https://www.geeksforgeeks.org/program-to-check-if-a-matrix-is-symmetric/)

如果矩阵的转置与给定矩阵相同，则称方矩阵为**对称矩阵**。 **对称矩阵**可以通过将行更改为列，将列更改为行来获得。

例子：

```
Input : 1 2 3
        2 1 4
        3 4 3
Output : Yes

Input : 3 5 8
        3 4 7
        8 5 3
Output : No

```

## [推荐：在继续进行解决之前，请先在 ***<u>{IDE}</u>*** 上尝试您的方法。](https://ide.geeksforgeeks.org/)

一个**简单解决方案**要执行以下操作。
1）创建给定矩阵的转置。
2）检查转置矩阵和给定矩阵是否相同，

## C++ 

```

// Simple c++ code for check a matrix is 
// symmetric or not. 
#include <iostream> 
using namespace std; 

const int MAX = 100; 

// Fills transpose of mat[N][N] in tr[N][N] 
void transpose(int mat[][MAX], int tr[][MAX], int N) 
{ 
    for (int i = 0; i < N; i++) 
        for (int j = 0; j < N; j++) 
            tr[i][j] = mat[j][i]; 
} 

// Returns true if mat[N][N] is symmetric, else false 
bool isSymmetric(int mat[][MAX], int N) 
{ 
    int tr[N][MAX]; 
    transpose(mat, tr, N); 
    for (int i = 0; i < N; i++) 
        for (int j = 0; j < N; j++) 
            if (mat[i][j] != tr[i][j]) 
                return false; 
    return true; 
} 

// Driver code 
int main() 
{ 
    int mat[][MAX] = { { 1, 3, 5 }, 
                       { 3, 2, 4 }, 
                       { 5, 4, 1 } }; 

    if (isSymmetric(mat, 3)) 
        cout << "Yes"; 
    else
        cout << "No"; 
    return 0; 
} 

```