# 使用 STL 的第 K 个最小/最大元素

> 原文： [https://www.geeksforgeeks.org/kth-smallestlargest-element-using-stl/](https://www.geeksforgeeks.org/kth-smallestlargest-element-using-stl/)

给定一个数组和一个数 k（其中 k 小于数组的大小），我们需要找到给定数组中第 k 个最小的元素。

例子：

```
Input : arr[] = {7, 10, 4, 3, 20, 15}
            k = 2
Output : 4
Smallest element is 3\. Second smallest
is 4.

Input : arr[] = {7, 10, 4, 3, 3, 15}
            k = 2
Output : 4
Even if there are more than one occurrences
of 3, answer should be 4.

Input :arr[] = {7, 10, 4, 3, 20, 15}
          k = 4
Output : 10

```

## [推荐：在继续进行解决之前，请先在 ***<u>{IDE}</u>*** 上尝试您的方法。](https://ide.geeksforgeeks.org/)

我们使用在 C++  STL 中设置的[。
1）将所有元素插入集合。
2）遍历设置并打印第 k 个元素。](https://www.geeksforgeeks.org/set-in-cpp-stl/)

```

// STL based C++ program to find k-th smallest 
// element. 
#include <bits/stdc++.h> 
using namespace std; 

int kthSmallest(int arr[], int n, int k) 
{ 
    // Insert all elements into the set 
    set<int> s; 
    for (int i = 0; i < n; i++) 
        s.insert(arr[i]); 

    // Traverse set and print k-th element 
    auto it = s.begin(); 
    for (int i = 0; i < k - 1; i++) 
        it++; 
    return *it; 
} 

int main() 
{ 
    int arr[] = { 12, 3, 5, 7, 3, 19 }; 
    int n = sizeof(arr) / sizeof(arr[0]), k = 2; 
    cout << "K'th smallest element is "
         << kthSmallest(arr, n, k); 
    return 0; 
} 

```

输出：

```
K'th smallest element is 5 

```

上述解决方案的时间复杂度为 O（n Log n）。 请注意，STL 中的 set 在内部使用自平衡 BST，因此搜索和插入操作的时间复杂度为 O（log n）。

**相关文章**：

[未排序数组中第 K 个最小/最大元素| 集合 1](https://www.geeksforgeeks.org/kth-smallestlargest-element-unsorted-array/)
[未排序数组中第 K 个最小/最大元素| 集合 2（预期线性时间](https://www.geeksforgeeks.org/kth-smallestlargest-element-unsorted-array-set-2-expected-linear-time/)
[未排序数组中第 K 个最小/最大元素|集合 3（最坏情况的线性时间）](https://www.geeksforgeeks.org/kth-smallestlargest-element-unsorted-array-set-3-worst-case-linear-time/)

本文由 **Roshan Halwai** 提供。 如果您喜欢 GeeksforGeeks 并希望做出贡献，则也可以使用 [tribution.geeksforgeeks.org](http://www.contribute.geeksforgeeks.org) 撰写文章，或将您的文章邮寄至 tribution@geeksforgeeks.org。 查看您的文章出现在 GeeksforGeeks 主页上，并帮助其他 Geeks。

如果发现任何不正确的地方，或者想分享有关上述主题的更多信息，请写评论。

现在不要停下来，将您的学习提高到一个新的水平。 借助最受信任的课程，学习数据结构和算法的所有重要概念： [DSA Self Paced](https://practice.geeksforgeeks.org/courses/dsa-self-paced?utm_source=geeksforgeeks&utm_medium=article&utm_campaign=gfg_article_dsa_content_bottom) 。 以对学生友好的价格准备好行业。